config/routes.rb
# For details on the DSL available within this file, see http://guides.rubyonrails.org/routing.html

Rails.application.routes.draw do

  namespace :admin do
    resources :quotes

    get '/', to: redirect('admin/quotes')
  end

  scope module: 'front' do
    get '/quotes/random', to: 'quotes#random'

    root 'home#index'
  end

end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true

  def self.random
    return self.order("RANDOM()").first
  end
  
end

app/models/quote.rb
class Quote < ApplicationRecord

    validates :text, presence: true,
        length: { minimum: 5 }
        
    validates :author, presence: true,
        length: { minimum: 5 }
    
end

app/controllers/admin/application_controller.rb
class Admin::ApplicationController < ApplicationController
    layout 'admin/layouts/application'
end

app/controllers/admin/quotes_controller.rb
class Admin::QuotesController < Admin::ApplicationController
    
    def index
        @quotes = Quote.all    
    end

    def new
        @quote = Quote.new
    end

    def create
        @quote = Quote.new(quote_parameters)
        if @quote.save
            redirect_to admin_quotes_path
        else
            render 'new'
        end
    end

    def edit
        @quote = Quote.find(params[:id])
    end

    def update
        @quote = Quote.find(params[:id])
       
        if @quote.update(quote_parameters)
          redirect_to admin_quotes_path
        else
          render 'edit'
        end
    end

    def destroy
        @article = Quote.find(params[:id])
        @article.destroy
     
        redirect_to admin_quotes_path
    end
    
    private def quote_parameters
        params.require(:quote).permit(:text, :author)
    end

end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
end

app/controllers/front/application_controller.rb
class Front::ApplicationController < ApplicationController
    layout 'front/layouts/application'
end

app/controllers/front/home_controller.rb
class Front::HomeController < Front::ApplicationController
  
  def index
  end

end

app/controllers/front/quotes_controller.rb
class Front::QuotesController < Front::ApplicationController

  def random
    @quote = Quote.random

    render :json => {
      text: @quote.text,
      author: @quote.author
    }
  end

end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/quotes_helper.rb
module QuotesHelper
end

app/helpers/welcome_helper.rb
module WelcomeHelper
end

app/views/admin/layouts/application.html.erb
<!DOCTYPE html>
<html lang="en">
  <head>
    <%= render 'head' %>
  </head>

  <body class="<%= controller_path.gsub("/", " ") %>">

    <div class="page grid-x">
      <div class="column small-12 medium-4 large-2 sidebar">
        <div class="title">
          <%= link_to root_path do %>
            RandomQuote
          <% end %>
        </div>
        <div>
        </div>
        <div>
          <ul class="vertical menu">
            <li class="active">
              <%= link_to admin_quotes_path do %>
                <i class="fa fa-quote-right"></i> Quotes
              <% end %>
            </li>
          </ul>
        </div>
      </div>
      <div class="column small-12 medium-8 large-10 content">
        <%= yield %>
      </div>
    </div>

  </body>
</html>

app/views/admin/quotes/_form.html.erb
<%= form_with model: [:admin, @quote], local: true do |form| %>
 
  <% if @quote.errors.any? %>
    <div class="callout alert">
      <div>
        <%= pluralize(@quote.errors.count, "error") %> prohibited
        this quote from being saved:
      </div>
      <ul>
        <% @quote.errors.full_messages.each do |msg| %>
          <li><%= msg %></li>
        <% end %>
      </ul>
    </div>
  <% end %>
 
  <div class="grid-x">
    <div class="small-12 medium-8 large-5 cell">
      <label>
        <textarea name="quote[text]" placeholder="Text" rows="4"><%= @quote.text %></textarea>
      </label>
    </div>
  </div>

  <div class="grid-x">
    <div class="small-12 medium-8 large-5 cell">
      <label>Author
        <input type="text" name="quote[author]" placeholder="Author" value="<%= @quote.author %>">
      </label>
    </div>
  </div>

  <%= form.submit 'Confirm', :class => 'button' %>
  <%= link_to 'Cancel', admin_quotes_path, class: "button alert" %>
 
<% end %>

app/views/admin/quotes/edit.html.erb
<div class="card">
    <h1>Edit quote</h1>
    <%= render 'form' %>
</div>

app/views/admin/quotes/index.html.erb
<h1>Quotes</h1>

<div class="card crud">

  <div>
    <%= link_to new_admin_quote_path, class: "button new-button" do %>
      <i class="fa fa-plus"></i> Create new quote
    <% end %>
  </div>

  <table class="hover">
    <thead>
      <tr>
        <th>Text</th>
        <th width="200">Author</th>
        <th width="50"></th>
        <th width="50"></th>
      </tr>
    </thead>
  
    <tbody>
      <% @quotes.each do |quote| %>
        <tr>
          <td><%= quote.text %></td>
          <td><%= quote.author %></td>
          <td>
            <%= link_to edit_admin_quote_path(quote) do %>
              <i class="fa fa-pencil"></i>
            <% end %>
          </td>
          <td>
            <%= link_to admin_quote_path(quote),
              method: :delete,
              data: { confirm: 'Are you sure?' } do %>
              <i class="fa fa-trash"></i>
            <% end %>
          </td>
        </tr>
      <% end %>
    </tbody>
  </table>
</div>

app/views/admin/quotes/new.html.erb
<div class="card">
    <h1>New quote</h1>
    <%= render 'form' %>
</div>

app/views/application/_head.html.erb
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />

<title><%= content_for?(:title) ? yield(:title) : "RandomQuote" %></title>

<%= stylesheet_link_tag    "application" %>
<%= javascript_include_tag "application", 'data-turbolinks-track' => true %>
<%= javascript_pack_tag 'application' %>

<%= csrf_meta_tags %>

<script>
    jQuery(function() {
        jQuery(document).foundation();
    });
</script>

app/views/front/home/index.html.erb
<div class="admin-link">
    <%= link_to 'Admin', admin_quotes_path %>
</div>
<div>
    <div>
        <h1>RandomQuote</h1>
    </div>
    <div>
        <%= react_component("RandomQuote") %>
    </div>
</div>

app/views/front/layouts/application.html.erb
<!DOCTYPE html>
<html lang="en">
  <head>
    <%= render 'head' %>
  </head>

  <body class="<%= controller_path.gsub("/", " ") %>">

    <%= yield %>

  </body>
</html>

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html lang="en">
  <head>
    <%= render 'head' %>
  </head>

  <body class="<%= controller_path.gsub("/", " ") %>">
    <%= yield %>
  </body>
</html>